Index: squid/src/helper.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/helper.c,v
retrieving revision 1.1.1.3.12.13.2.6
retrieving revision 1.1.1.3.12.13.2.7
diff -u -r1.1.1.3.12.13.2.6 -r1.1.1.3.12.13.2.7
--- squid/src/helper.c	5 Jan 2001 23:43:58 -0000	1.1.1.3.12.13.2.6
+++ squid/src/helper.c	7 Jan 2001 09:48:31 -0000	1.1.1.3.12.13.2.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: helper.c,v 1.1.1.3.12.13.2.6 2001/01/05 23:43:58 rbcollins Exp $
+ * $Id: helper.c,v 1.1.1.3.12.13.2.7 2001/01/07 09:48:31 hno Exp $
  *
  * DEBUG: section 29    Helper process maintenance
  * AUTHOR: Harvest Derived?
@@ -53,7 +53,7 @@
 static void helperRequestFree(helper_request * r);
 static void helperStatefulRequestFree(helper_stateful_request * r);
 static void StatefulEnqueue(statefulhelper * hlp, helper_stateful_request * r);
-static helper_stateful_request * StatefulServerDequeue(helper_stateful_server * srv);
+static helper_stateful_request *StatefulServerDequeue(helper_stateful_server * srv);
 static void StatefulServerEnqueue(helper_stateful_server * srv, helper_stateful_request * r);
 static void helperStatefulServerKickQueue(helper_stateful_server * srv);
 
@@ -179,10 +179,10 @@
 	    continue;
 	}
 	hlp->n_running++;
-	srv = CBDATA_ALLOC(helper_stateful_server, NULL); 
+	srv = CBDATA_ALLOC(helper_stateful_server, NULL);
 	srv->flags.alive = 1;
-        srv->flags.reserved = S_HELPER_FREE;
-        srv->deferred_requests=0;
+	srv->flags.reserved = S_HELPER_FREE;
+	srv->deferred_requests = 0;
 	srv->index = k;
 	srv->rfd = rfd;
 	srv->wfd = wfd;
@@ -190,8 +190,8 @@
 	srv->buf_sz = 8192;
 	srv->offset = 0;
 	srv->parent = hlp;
-        if (hlp->datapool != NULL) 
-            srv->data = memPoolAlloc(hlp->datapool);
+	if (hlp->datapool != NULL)
+	    srv->data = memPoolAlloc(hlp->datapool);
 	cbdataLock(hlp);	/* lock because of the parent backlink */
 	dlinkAddTail(srv, &srv->link, &hlp->servers);
 	if (rfd == wfd) {
@@ -232,7 +232,7 @@
 	helperDispatch(srv, r);
     else
 	Enqueue(hlp, r);
-   debug(29,9) ("helperSubmit: %s\n",buf);
+    debug(29, 9) ("helperSubmit: %s\n", buf);
 }
 
 void
@@ -242,134 +242,126 @@
     helper_stateful_server *srv;
     if (hlp == NULL) {
 	debug(29, 3) ("helperStatefulSubmit: hlp == NULL\n");
-	callback(data,0,  NULL);
+	callback(data, 0, NULL);
 	return;
     }
     r->callback = callback;
     r->data = data;
-    if (buf != NULL) 
-        r->buf = xstrdup(buf);
+    if (buf != NULL)
+	r->buf = xstrdup(buf);
     else
-        r->placeholder=1;
+	r->placeholder = 1;
     cbdataLock(r->data);
-    if ((buf != NULL) && lastserver){
-        debug(29,5)("StatefulSubmit with lastserver %d\n",lastserver);
-        if (lastserver->flags.reserved!=S_HELPER_RESERVED)
-             lastserver->deferred_requests--;
-        if (!(lastserver->request)) {
-        debug(29,5)("StatefulSubmit dispatching\n");
-             helperStatefulDispatch(lastserver, r);
-        } else {
-        debug(29,5)("StatefulSubmit queuing\n");
-             StatefulServerEnqueue(lastserver, r);
-        }
-    }
-    else
-    {
-    if ((srv = StatefulGetFirstAvailable(hlp))){
-	helperStatefulDispatch(srv, r);
-    }
-    else
-	StatefulEnqueue(hlp, r);
+    if ((buf != NULL) && lastserver) {
+	debug(29, 5) ("StatefulSubmit with lastserver %d\n", lastserver);
+	if (lastserver->flags.reserved != S_HELPER_RESERVED)
+	    lastserver->deferred_requests--;
+	if (!(lastserver->request)) {
+	    debug(29, 5) ("StatefulSubmit dispatching\n");
+	    helperStatefulDispatch(lastserver, r);
+	} else {
+	    debug(29, 5) ("StatefulSubmit queuing\n");
+	    StatefulServerEnqueue(lastserver, r);
+	}
+    } else {
+	if ((srv = StatefulGetFirstAvailable(hlp))) {
+	    helperStatefulDispatch(srv, r);
+	} else
+	    StatefulEnqueue(hlp, r);
     }
-   debug(29,9) ("helperStatefulSubmit: placeholder: '%d', buf '%s'.\n",r->placeholder,buf);
+    debug(29, 9) ("helperStatefulSubmit: placeholder: '%d', buf '%s'.\n", r->placeholder, buf);
 }
 
 helper_stateful_server *
-helperStatefulDefer(statefulhelper *hlp)
+helperStatefulDefer(statefulhelper * hlp)
 /* find and add a deferred request to a server */
 {
     dlink_node *n;
     helper_stateful_server *srv = NULL, *rv = NULL;
     if (hlp == NULL) {
-        debug(29, 3) ("helperStatefulReserve: hlp == NULL\n");
-        return NULL;
+	debug(29, 3) ("helperStatefulReserve: hlp == NULL\n");
+	return NULL;
     }
-    debug(29,5)("helperStatefulDefer: Running servers %d.\n",hlp->n_running);
-    if (hlp->n_running == 0)
-    {
-        debug(29,1)("helperStatefulDefer: No running servers!. \n");
-        return NULL;
+    debug(29, 5) ("helperStatefulDefer: Running servers %d.\n", hlp->n_running);
+    if (hlp->n_running == 0) {
+	debug(29, 1) ("helperStatefulDefer: No running servers!. \n");
+	return NULL;
     }
-    
     srv = StatefulGetFirstAvailable(hlp);
     /* all currently busy:loop through servers and find server with the shortest queue */
     rv = srv;
     if (rv == NULL)
-    for (n = hlp->servers.head; n != NULL; n = n->next) {
-        srv = n->data;
-        if (srv->flags.reserved==S_HELPER_RESERVED)
-            continue;
-        if (!srv->flags.alive)
-            continue;
-        if ((hlp->IsAvailable != NULL) && (srv->data != NULL) && 
-            !(hlp->IsAvailable(srv->data)))
-            continue;
-        if ((rv != NULL) && (rv->deferred_requests<srv->deferred_requests))
-            continue;
-        rv = srv;
-    }
-    if (rv == NULL)
-    {
-        debug(29,1)("helperStatefulDefer: None available.\n");
-        return NULL;
+	for (n = hlp->servers.head; n != NULL; n = n->next) {
+	    srv = n->data;
+	    if (srv->flags.reserved == S_HELPER_RESERVED)
+		continue;
+	    if (!srv->flags.alive)
+		continue;
+	    if ((hlp->IsAvailable != NULL) && (srv->data != NULL) &&
+		!(hlp->IsAvailable(srv->data)))
+		continue;
+	    if ((rv != NULL) && (rv->deferred_requests < srv->deferred_requests))
+		continue;
+	    rv = srv;
+	}
+    if (rv == NULL) {
+	debug(29, 1) ("helperStatefulDefer: None available.\n");
+	return NULL;
     }
-
-    rv->flags.reserved=S_HELPER_DEFERRED;
+    rv->flags.reserved = S_HELPER_DEFERRED;
     rv->deferred_requests++;
     return rv;
 }
 
-void 
+void
 helperStatefulReset(helper_stateful_server * srv)
 /* puts this helper back in the queue. the calling app is required to 
  * manage the state in the helper.
  */
 {
-    statefulhelper * hlp = srv->parent;
-    helper_stateful_request * r;
+    statefulhelper *hlp = srv->parent;
+    helper_stateful_request *r;
     r = srv->request;
     if (r != NULL) {
-        /* reset attempt DURING an outstaning request */
-        debug(29, 1) ("helperStatefulReset: RESET During request %s \n",
-            hlp->id_name);
-        srv->flags.busy = 0;
-        srv->offset = 0;
-        helperStatefulRequestFree(r);
-        srv->request = NULL;
-    } 
-    debug(29,1)("helperStatefulReset reset helper %s #%d\n",hlp->id_name,srv->index+1);
+	/* reset attempt DURING an outstaning request */
+	debug(29, 1) ("helperStatefulReset: RESET During request %s \n",
+	    hlp->id_name);
+	srv->flags.busy = 0;
+	srv->offset = 0;
+	helperStatefulRequestFree(r);
+	srv->request = NULL;
+    }
+    debug(29, 1) ("helperStatefulReset reset helper %s #%d\n", hlp->id_name, srv->index + 1);
     srv->flags.busy = 0;
-    if (srv->queue.head){
-        srv->flags.reserved=S_HELPER_DEFERRED;
-        helperStatefulServerKickQueue(srv);
-    }else{
-        srv->flags.reserved=S_HELPER_FREE;
-        if ((srv->parent->OnEmptyQueue != NULL) && (srv->data))
-            srv->parent->OnEmptyQueue(srv->data);
-        helperStatefulKickQueue(hlp);
+    if (srv->queue.head) {
+	srv->flags.reserved = S_HELPER_DEFERRED;
+	helperStatefulServerKickQueue(srv);
+    } else {
+	srv->flags.reserved = S_HELPER_FREE;
+	if ((srv->parent->OnEmptyQueue != NULL) && (srv->data))
+	    srv->parent->OnEmptyQueue(srv->data);
+	helperStatefulKickQueue(hlp);
     }
 }
 
 void
 helperStatefulReleaseServer(helper_stateful_server * srv)
-/*decrease the number of 'waiting' clients that set the helper to be DEFERRED*/
+/*decrease the number of 'waiting' clients that set the helper to be DEFERRED */
 {
-  if (srv->deferred_requests>0)
-     srv->deferred_requests--;  
-  if (!(srv->deferred_requests) && (srv->flags.reserved==S_HELPER_DEFERRED) && !(srv->queue.head))
-  {
-     srv->flags.reserved=S_HELPER_FREE;
-     if ((srv->parent->OnEmptyQueue != NULL) && (srv->data))
-         srv->parent->OnEmptyQueue(srv->data);
-  }
+    if (srv->deferred_requests > 0)
+	srv->deferred_requests--;
+    if (!(srv->deferred_requests) && (srv->flags.reserved == S_HELPER_DEFERRED) && !(srv->queue.head)) {
+	srv->flags.reserved = S_HELPER_FREE;
+	if ((srv->parent->OnEmptyQueue != NULL) && (srv->data))
+	    srv->parent->OnEmptyQueue(srv->data);
+    }
 }
 
 void *
 helperStatefulServerGetData(helper_stateful_server * srv)
 /* return a pointer to the stateful routines data area */
 {
-  return srv->data;
+    return srv->data;
 }
 
 void
@@ -426,41 +418,41 @@
     dlink_node *link;
     double tt;
     storeAppendPrintf(sentry, "number running: %d of %d\n",
-        hlp->n_running, hlp->n_to_start);
+	hlp->n_running, hlp->n_to_start);
     storeAppendPrintf(sentry, "requests sent: %d\n",
-        hlp->stats.requests);
+	hlp->stats.requests);
     storeAppendPrintf(sentry, "replies received: %d\n",
-        hlp->stats.replies);
+	hlp->stats.replies);
     storeAppendPrintf(sentry, "queue length: %d\n",
-        hlp->stats.queue_size);
+	hlp->stats.queue_size);
     storeAppendPrintf(sentry, "avg service time: %d msec\n",
-        hlp->stats.avg_svc_time);
+	hlp->stats.avg_svc_time);
     storeAppendPrintf(sentry, "\n");
     storeAppendPrintf(sentry, "%7s\t%7s\t%11s\t%s\t%7s\t%7s\t%7s\n",
-        "#",
-        "FD",
-        "# Requests",
-        "# Deferred Requests",
-        "Flags",
-        "Time",
-        "Offset",
-        "Request");
+	"#",
+	"FD",
+	"# Requests",
+	"# Deferred Requests",
+	"Flags",
+	"Time",
+	"Offset",
+	"Request");
     for (link = hlp->servers.head; link; link = link->next) {
-        srv = link->data;
-        tt = 0.001 * tvSubMsec(srv->dispatch_time, current_time);
-        storeAppendPrintf(sentry, "%7d\t%7d\t%11d\t%11d\t%c%c%c%c%c\t%7.3f\t%7d\t%s\n",
-            srv->index + 1,
-            srv->rfd,
-            srv->stats.uses,
-            srv->deferred_requests,
-            srv->flags.alive ? 'A' : ' ',
-            srv->flags.busy ? 'B' : ' ',
-            srv->flags.closing ? 'C' : ' ',
-            srv->flags.reserved!=S_HELPER_FREE ? 'R': ' ',
-            srv->flags.shutdown ? 'S' : ' ',
-            tt < 0.0 ? 0.0 : tt,
-            (int) srv->offset,
-            srv->request ? log_quote(srv->request->buf) : "(none)");
+	srv = link->data;
+	tt = 0.001 * tvSubMsec(srv->dispatch_time, current_time);
+	storeAppendPrintf(sentry, "%7d\t%7d\t%11d\t%11d\t%c%c%c%c%c\t%7.3f\t%7d\t%s\n",
+	    srv->index + 1,
+	    srv->rfd,
+	    srv->stats.uses,
+	    srv->deferred_requests,
+	    srv->flags.alive ? 'A' : ' ',
+	    srv->flags.busy ? 'B' : ' ',
+	    srv->flags.closing ? 'C' : ' ',
+	    srv->flags.reserved != S_HELPER_FREE ? 'R' : ' ',
+	    srv->flags.shutdown ? 'S' : ' ',
+	    tt < 0.0 ? 0.0 : tt,
+	    (int) srv->offset,
+	    srv->request ? log_quote(srv->request->buf) : "(none)");
     }
     storeAppendPrintf(sentry, "\nFlags key:\n\n");
     storeAppendPrintf(sentry, "   A = ALIVE\n");
@@ -524,16 +516,16 @@
 		hlp->id_name, srv->index + 1);
 	    continue;
 	}
-        if (srv->flags.reserved!=S_HELPER_FREE) {
-            debug(34, 3) ("helperStatefulShutdown: %s #%d is RESERVED.\n",
-                hlp->id_name, srv->index + 1);
-            continue;
-        }
-        if (srv->deferred_requests) {
-            debug(34, 3) ("helperStatefulShutdown: %s #%d has DEFERRED requests.\n",
-                hlp->id_name, srv->index + 1);
-            continue;
-        }
+	if (srv->flags.reserved != S_HELPER_FREE) {
+	    debug(34, 3) ("helperStatefulShutdown: %s #%d is RESERVED.\n",
+		hlp->id_name, srv->index + 1);
+	    continue;
+	}
+	if (srv->deferred_requests) {
+	    debug(34, 3) ("helperStatefulShutdown: %s #%d has DEFERRED requests.\n",
+		hlp->id_name, srv->index + 1);
+	    continue;
+	}
 	srv->flags.closing = 1;
 	comm_close(srv->wfd);
 	srv->wfd = -1;
@@ -630,7 +622,7 @@
     }
     if ((r = srv->request)) {
 	if (cbdataValid(r->data))
-	    r->callback(r->data, srv,srv->buf);
+	    r->callback(r->data, srv, srv->buf);
 	helperStatefulRequestFree(r);
 	srv->request = NULL;
     }
@@ -646,7 +638,7 @@
 	    fatalf("Too few %s processes are running", hlp->id_name);
     }
     if (srv->data != NULL)
-        memPoolFree(hlp->datapool,srv->data);
+	memPoolFree(hlp->datapool, srv->data);
     cbdataUnlock(srv->parent);
     cbdataFree(srv);
 }
@@ -739,46 +731,46 @@
 	/* end of reply found */
 	debug(29, 3) ("helperStatefulHandleRead: end of reply found\n");
 	*t = '\0';
-	if (cbdataValid(r->data)){
-	    switch((r->callback(r->data,srv, srv->buf))){ /*if non-zero reserve helper */
-	         case S_HELPER_UNKNOWN:
-                     fatal("helperStatefulHandleRead: either a non-state aware callback was give to the stateful helper routines, or an uninitialised callback response was recieved.\n");
-                     break;
-                 case S_HELPER_RELEASE: /* helper finished with */
-                     if (!srv->queue.head){
-                         srv->flags.reserved = S_HELPER_FREE;
-                         if ((srv->parent->OnEmptyQueue != NULL) && (srv->data))
-                             srv->parent->OnEmptyQueue(srv->data);
-                         debug(29, 5)("StatefulHandleRead: releasing %s #%d\n",hlp->id_name, srv->index+1);
-                     }else{
-                         srv->flags.reserved = S_HELPER_DEFERRED;
-                         debug(29, 5)("StatefulHandleRead: outstanding deferred requests on %s #%d. reserving for deferred requests.\n",hlp->id_name, srv->index+1);
-                     }
-                     break;
-                 case S_HELPER_RESERVE: /* 'pin' this helper for the caller */
-                     if (!srv->queue.head){
-                         srv->flags.reserved = S_HELPER_RESERVED;
-                         debug(29, 5)("StatefulHandleRead: reserving %s #%d\n",hlp->id_name, srv->index+1);
-                     }else{
-                         fatal("StatefulHandleRead: Callback routine attempted to reserve a stateful helper with deferred requests. This can lead to deadlock.\n");
-                     }
-                     break;
-                 case S_HELPER_DEFER:
-                 /* the helper is still needed, but can
-                  * be used for other requests in the meantime.
-                  */
-                     srv->flags.reserved = S_HELPER_DEFERRED;
-                     srv->deferred_requests++;
-                     debug(29, 5)("StatefulHandleRead: reserving %s #%d for deferred requests.\n",hlp->id_name, srv->index+1);
-                     break;
-                 default:
-                     fatal("helperStatefulHandleRead: unknown stateful helper callback result.\n");
-                 }
-             
-            }
-        else
-        {debug(29,1)("StatefulHandleRead: no callback data registered\n");}
-        srv->flags.busy = 0;
+	if (cbdataValid(r->data)) {
+	    switch ((r->callback(r->data, srv, srv->buf))) {	/*if non-zero reserve helper */
+	    case S_HELPER_UNKNOWN:
+		fatal("helperStatefulHandleRead: either a non-state aware callback was give to the stateful helper routines, or an uninitialised callback response was recieved.\n");
+		break;
+	    case S_HELPER_RELEASE:	/* helper finished with */
+		if (!srv->queue.head) {
+		    srv->flags.reserved = S_HELPER_FREE;
+		    if ((srv->parent->OnEmptyQueue != NULL) && (srv->data))
+			srv->parent->OnEmptyQueue(srv->data);
+		    debug(29, 5) ("StatefulHandleRead: releasing %s #%d\n", hlp->id_name, srv->index + 1);
+		} else {
+		    srv->flags.reserved = S_HELPER_DEFERRED;
+		    debug(29, 5) ("StatefulHandleRead: outstanding deferred requests on %s #%d. reserving for deferred requests.\n", hlp->id_name, srv->index + 1);
+		}
+		break;
+	    case S_HELPER_RESERVE:	/* 'pin' this helper for the caller */
+		if (!srv->queue.head) {
+		    srv->flags.reserved = S_HELPER_RESERVED;
+		    debug(29, 5) ("StatefulHandleRead: reserving %s #%d\n", hlp->id_name, srv->index + 1);
+		} else {
+		    fatal("StatefulHandleRead: Callback routine attempted to reserve a stateful helper with deferred requests. This can lead to deadlock.\n");
+		}
+		break;
+	    case S_HELPER_DEFER:
+		/* the helper is still needed, but can
+		 * be used for other requests in the meantime.
+		 */
+		srv->flags.reserved = S_HELPER_DEFERRED;
+		srv->deferred_requests++;
+		debug(29, 5) ("StatefulHandleRead: reserving %s #%d for deferred requests.\n", hlp->id_name, srv->index + 1);
+		break;
+	    default:
+		fatal("helperStatefulHandleRead: unknown stateful helper callback result.\n");
+	    }
+
+	} else {
+	    debug(29, 1) ("StatefulHandleRead: no callback data registered\n");
+	}
+	srv->flags.busy = 0;
 	srv->offset = 0;
 	helperStatefulRequestFree(r);
 	srv->request = NULL;
@@ -791,11 +783,11 @@
 	    comm_close(srv->wfd);
 	    srv->wfd = -1;
 	} else {
-            if (srv->queue.head) 
-                helperStatefulServerKickQueue(srv);
-            else
- 	        helperStatefulKickQueue(hlp);
-       }
+	    if (srv->queue.head)
+		helperStatefulServerKickQueue(srv);
+	    else
+		helperStatefulKickQueue(hlp);
+	}
     } else {
 	commSetSelect(srv->rfd, COMM_SELECT_READ, helperStatefulHandleRead, srv, 0);
     }
@@ -841,24 +833,24 @@
     debug(14, 1) ("Consider increasing the number of %s processes in your config file.\n", hlp->id_name);
 }
 
-static void 
+static void
 StatefulServerEnqueue(helper_stateful_server * srv, helper_stateful_request * r)
 {
     dlink_node *link = memAllocate(MEM_DLINK_NODE);
     dlinkAddTail(r, link, &srv->queue);
 /*    hlp->stats.queue_size++;
-    if (hlp->stats.queue_size < hlp->n_running)
-        return;
-    if (squid_curtime - hlp->last_queue_warn < 600)
-        return;
-    if (shutting_down || reconfiguring)
-        return;
-    hlp->last_queue_warn = squid_curtime;
-    debug(14, 0) ("WARNING: All %s processes are busy.\n", hlp->id_name);
-    debug(14, 0) ("WARNING: %d pending requests queued\n", hlp->stats.queue_size);
-    if (hlp->stats.queue_size > hlp->n_running * 2)
-        fatalf("Too many queued %s requests", hlp->id_name);
-    debug(14, 1) ("Consider increasing the number of %s processes in your config file.\n", hlp->id_name);  */
+ * if (hlp->stats.queue_size < hlp->n_running)
+ * return;
+ * if (squid_curtime - hlp->last_queue_warn < 600)
+ * return;
+ * if (shutting_down || reconfiguring)
+ * return;
+ * hlp->last_queue_warn = squid_curtime;
+ * debug(14, 0) ("WARNING: All %s processes are busy.\n", hlp->id_name);
+ * debug(14, 0) ("WARNING: %d pending requests queued\n", hlp->stats.queue_size);
+ * if (hlp->stats.queue_size > hlp->n_running * 2)
+ * fatalf("Too many queued %s requests", hlp->id_name);
+ * debug(14, 1) ("Consider increasing the number of %s processes in your config file.\n", hlp->id_name);  */
 }
 
 
@@ -885,7 +877,7 @@
 	r = link->data;
 	dlinkDelete(link, &srv->queue);
 	memFree(link, MEM_DLINK_NODE);
-//	hlp->stats.queue_size--;
+//      hlp->stats.queue_size--;
     }
     return r;
 }
@@ -896,10 +888,10 @@
     dlink_node *link;
     helper_stateful_request *r = NULL;
     if ((link = hlp->queue.head)) {
-        r = link->data;
-        dlinkDelete(link, &hlp->queue);
-        memFree(link, MEM_DLINK_NODE);
-        hlp->stats.queue_size--;
+	r = link->data;
+	dlinkDelete(link, &hlp->queue);
+	memFree(link, MEM_DLINK_NODE);
+	hlp->stats.queue_size--;
     }
     return r;
 }
@@ -927,22 +919,22 @@
 {
     dlink_node *n;
     helper_stateful_server *srv = NULL;
-    debug(29,5)("StatefulGetFirstAvailable: Running servers %d.\n",hlp->n_running);
+    debug(29, 5) ("StatefulGetFirstAvailable: Running servers %d.\n", hlp->n_running);
     if (hlp->n_running == 0)
 	return NULL;
     for (n = hlp->servers.head; n != NULL; n = n->next) {
 	srv = n->data;
 	if (srv->flags.busy)
 	    continue;
-        if (srv->flags.reserved==S_HELPER_RESERVED)
-            continue;
+	if (srv->flags.reserved == S_HELPER_RESERVED)
+	    continue;
 	if (!srv->flags.alive)
 	    continue;
-        if ((hlp->IsAvailable != NULL) && (srv->data != NULL) && !(hlp->IsAvailable(srv->data)))
-            continue;
-    	return srv;
+	if ((hlp->IsAvailable != NULL) && (srv->data != NULL) && !(hlp->IsAvailable(srv->data)))
+	    continue;
+	return srv;
     }
-    debug(29,5)("StatefulGetFirstAvailable: None available.\n");
+    debug(29, 5) ("StatefulGetFirstAvailable: None available.\n");
     return NULL;
 }
 
@@ -980,40 +972,35 @@
 helperStatefulDispatch(helper_stateful_server * srv, helper_stateful_request * r)
 {
     statefulhelper *hlp = srv->parent;
-        if (!cbdataValid(r->data)) {
+    if (!cbdataValid(r->data)) {
 	debug(29, 1) ("helperStatefulDispatch: invalid callback data\n");
 	helperStatefulRequestFree(r);
 	return;
     }
-   debug(29,9)("helperStatefulDispatch busying helper %s #%d\n",hlp->id_name,srv->index+1);
-    if (r->placeholder==1)
-    {
-        /* a callback is needed before this request can _use_ a helper. */
-        if (cbdataValid(r->data)){
-            /* we don't care about releasing/deferring this helper. The request NEVER
-             * gets to the helper. So we throw away the return code */
-            r->callback(r->data, srv, NULL);
-            /* throw away the placeholder */
-            helperStatefulRequestFree(r);   
-            /* and push the queue. Note that the callback may have call submit again - 
-             * which is why we test for the request*/
-            if (srv->request == NULL)
-            {
-                if (srv->flags.shutdown) 
-                {
-                    comm_close(srv->wfd);
-                    srv->wfd = -1;
-                }
-                else
-                {
-                    if (srv->queue.head)
-                        helperStatefulServerKickQueue(srv);
-                    else
-                        helperStatefulKickQueue(hlp);
-                }
-            }
-        }
-        return;
+    debug(29, 9) ("helperStatefulDispatch busying helper %s #%d\n", hlp->id_name, srv->index + 1);
+    if (r->placeholder == 1) {
+	/* a callback is needed before this request can _use_ a helper. */
+	if (cbdataValid(r->data)) {
+	    /* we don't care about releasing/deferring this helper. The request NEVER
+	     * gets to the helper. So we throw away the return code */
+	    r->callback(r->data, srv, NULL);
+	    /* throw away the placeholder */
+	    helperStatefulRequestFree(r);
+	    /* and push the queue. Note that the callback may have call submit again - 
+	     * which is why we test for the request*/
+	    if (srv->request == NULL) {
+		if (srv->flags.shutdown) {
+		    comm_close(srv->wfd);
+		    srv->wfd = -1;
+		} else {
+		    if (srv->queue.head)
+			helperStatefulServerKickQueue(srv);
+		    else
+			helperStatefulKickQueue(hlp);
+		}
+	    }
+	}
+	return;
     }
     srv->flags.busy = 1;
     srv->request = r;
@@ -1058,7 +1045,7 @@
 {
     helper_stateful_request *r;
     if ((r = StatefulServerDequeue(srv)))
-        helperStatefulDispatch(srv, r);
+	helperStatefulDispatch(srv, r);
 }
 
 static void
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.1.1.3.4.1.2.10.2.5
retrieving revision 1.1.1.3.4.1.2.10.2.6
diff -u -r1.1.1.3.4.1.2.10.2.5 -r1.1.1.3.4.1.2.10.2.6
--- squid/src/http.c	7 Jan 2001 00:37:02 -0000	1.1.1.3.4.1.2.10.2.5
+++ squid/src/http.c	7 Jan 2001 09:48:31 -0000	1.1.1.3.4.1.2.10.2.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.1.1.3.4.1.2.10.2.5 2001/01/07 00:37:02 hno Exp $
+ * $Id: http.c,v 1.1.1.3.4.1.2.10.2.6 2001/01/07 09:48:31 hno Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -693,7 +693,7 @@
 	     * authentication forwarding is explicitly enabled
 	     */
 	    if (request->flags.proxying && orig_request->peer_login &&
-		    strcmp(orig_request->peer_login, "PASS") == 0) {
+		strcmp(orig_request->peer_login, "PASS") == 0) {
 		httpHeaderAddEntry(hdr_out, httpHeaderEntryClone(e));
 	    }
 	    break;
@@ -791,7 +791,7 @@
     /* append Proxy-Authorization if configured for peer, and proxying */
     if (!httpHeaderHas(hdr_out, HDR_PROXY_AUTHORIZATION)) {
 	if (request->flags.proxying && orig_request->peer_login &&
-		strcmp(orig_request->peer_login, "PASS") != 0) {
+	    strcmp(orig_request->peer_login, "PASS") != 0) {
 	    httpHeaderPutStrf(hdr_out, HDR_PROXY_AUTHORIZATION, "Basic %s",
 		base64_encode(orig_request->peer_login));
 	}
@@ -879,7 +879,7 @@
 	cfd = entry->mem_obj->fd;
     assert(-1 == cfd || FD_SOCKET == fd_table[cfd].type);
     if (p != NULL)
-    httpState->flags.proxying = (p != NULL);
+	httpState->flags.proxying = (p != NULL);
     /*
      * Is keep-alive okay for all request methods?
      */
@@ -987,8 +987,8 @@
 static void
 httpRequestBodyHandler(char *buf, size_t size, void *data)
 {
-    HttpStateData *httpState = (HttpStateData *)data;
-    if ( size > 0 ) {
+    HttpStateData *httpState = (HttpStateData *) data;
+    if (size > 0) {
 	comm_write(httpState->fd, buf, size, httpSendRequestEntry, data, memFree8K);
     } else if (size == 0) {
 	/* End of body */
Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.1.1.3.4.1.2.12.2.5
retrieving revision 1.1.1.3.4.1.2.12.2.6
diff -u -r1.1.1.3.4.1.2.12.2.5 -r1.1.1.3.4.1.2.12.2.6
--- squid/src/main.c	5 Jan 2001 22:45:27 -0000	1.1.1.3.4.1.2.12.2.5
+++ squid/src/main.c	7 Jan 2001 09:48:31 -0000	1.1.1.3.4.1.2.12.2.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.1.1.3.4.1.2.12.2.5 2001/01/05 22:45:27 rbcollins Exp $
+ * $Id: main.c,v 1.1.1.3.4.1.2.12.2.6 2001/01/07 09:48:31 hno Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -349,7 +349,7 @@
     parseConfigFile(ConfigFile);
     _db_init(Config.Log.log, Config.debugOptions);
     ipcache_restart();		/* clear stuck entries */
-    authenticateUserCacheRestart(); /* clear stuck ACL entries */
+    authenticateUserCacheRestart();	/* clear stuck ACL entries */
     fqdncache_restart();	/* sigh, fqdncache too */
     parseEtcHosts();
     errorInitialize();		/* reload error pages */
@@ -633,7 +633,7 @@
 	cbdataInit();
 	eventInit();		/* eventInit() is required for config parsing */
 	storeFsInit();		/* required for config parsing */
-        authenticateSchemeInit(); /* required for config parsign */
+	authenticateSchemeInit();	/* required for config parsign */
 	parse_err = parseConfigFile(ConfigFile);
 
 	if (opt_parse_cfg_only)
Index: squid/src/mem.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/mem.c,v
retrieving revision 1.1.1.3.12.9.2.2
retrieving revision 1.1.1.3.12.9.2.3
diff -u -r1.1.1.3.12.9.2.2 -r1.1.1.3.12.9.2.3
--- squid/src/mem.c	7 Jan 2001 00:24:26 -0000	1.1.1.3.12.9.2.2
+++ squid/src/mem.c	7 Jan 2001 09:48:31 -0000	1.1.1.3.12.9.2.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: mem.c,v 1.1.1.3.12.9.2.2 2001/01/07 00:24:26 rbcollins Exp $
+ * $Id: mem.c,v 1.1.1.3.12.9.2.3 2001/01/07 09:48:31 hno Exp $
  *
  * DEBUG: section 13    High Level Memory Pool Management
  * AUTHOR: Harvest Derived
@@ -211,9 +211,9 @@
 	sizeof(acl_proxy_auth_data), 0);
 #endif
     memDataInit(MEM_AUTH_USER_HASH, "auth_user_hash_pointer",
-        sizeof(auth_user_hash_pointer),0);
+	sizeof(auth_user_hash_pointer), 0);
     memDataInit(MEM_ACL_PROXY_AUTH_MATCH, "acl_proxy_auth_match_cache",
-        sizeof(acl_proxy_auth_match_cache),0);
+	sizeof(acl_proxy_auth_match_cache), 0);
     memDataInit(MEM_CACHEMGR_PASSWD, "cachemgr_passwd",
 	sizeof(cachemgr_passwd), 0);
 #if USE_CACHE_DIGESTS
